Index: branch/fall/sp4a12/main.c
===================================================================
--- branch/fall/sp4a12/main.c	(revision 207)
+++ branch/fall/sp4a12/main.c	(revision 208)
@@ -1,76 +1,134 @@
-#include <stdio.h>
-#include <stdlib.h>
-#include <strings.h>
-#include "trame.h"
-
-//Trames de tests à modifier si nécessaire.
-char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
-                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
-                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
-                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
-                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
-                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
-                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
-                    "$GPZDA,141914.00,01,02,2006,00,00*69",
-                    0};
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
+#include "trame.h"
 
-int trame_cmp(char* a,char* b){
+//Trames de tests à modifier si nécessaire.
+char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
+                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
+                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
+                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
+                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
+                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
+                    "$GPZDA,141914.00,01,02,2006,00,00*69",
+                    0};
+
+int trame_cmp(char* trame,char* type)
+{
+    int i=1;
+    int comp = 1;
+    int end_comp=1;
+        while(end_comp!='\0')
+        {
+            if (trame[i]!=type[i-1])
+            {
+                comp = 0;
+            }
+            i=i+1;
+            end_comp=type[i];
+        }
+  return comp;
+
+}
+
+//Fonction à modifier !!!!!
+void traitement(char * trame)
+{
+    static int cpt=0 ;
+    cpt++ ;
+
+    if ((trame_cmp(trame,"GPGGA")) == 1)
+    {
+        printf("> %s\n",trame);
+    }
+
+}
+
+
+//Ajouter vos tests unitaires dans cette fonction.
+void tests_unitaires(void){
+    if (5!=5){
+        printf ("Erreur Test unitaire basique.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC... ", "GPRMC" )!=1){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$APRMC...", "GPGGA")!=0){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+
+void test_decode_nombre(void)
+{
+    if (decode_nombre("7541",1)!=7)
+    {
+        printf("Erreur test unitaire decode nombre\n");
+        exit(-1);
+    }
+    if (decode_nombre("7541",2)!=75)
+    {void test_decode_nombre(void)
+{
+    if (decode_nombre("7541",1)!=7)
+    {
+        printf("Erreur test unitaire decode nombre\n");
+        exit(-1);
+    }
+    if (decode_nombre("7541",2)!=75)
+    {
+        printf("Erreur test unitaire decode nombre\n");
+        exit(-1);
+    }
+        if (decode_nombre("7541",3)!=754)
+    {
+        printf("Erreur test unitaire decode nombre\n");
+        exit(-1);
+    }
+
+}
+
+        printf("Erreur test unitaire decode nombre\n");
+        exit(-1);
+    }
+        if (decode_nombre("7541",3)!=754)
+    {
+        printf("Erreur test unitaire decode nombre\n");
+        exit(-1);
+    }
+
+}
+
+        exit(-1);
+    }
+}
+
+// Ne pas modifier cette fonction
+int main(int argc,char ** argv)
+{
+
+    tests_unitaires();
+
+    // Affichage des trames definies dans la table trames.
+    printf ("Trames de tests tableau trames:\n");
+    int i=0;
+    while (trames[i])
+        traitement(trames[i++]);
+
+    if (!trame_init())
+        exit(-1);
+    // Affichage des trames du fichier gps.log
+    char *trame;
+    printf ("Trames de tests du fichier gps.log\n");
+    while  ((trame = trame_suivante()))
+        traitement(trame);
+
     return 0;
 }
-
-//Fonction à modifier !!!!!
-void traitement(char * trame)
-{
-    static int cpt=0;
-    cpt++;
-    if (trame_cmp(trame,"GPGGA"))
-        {printf ("> %s\n",trame);}
-    printf ("> %s\n",trame);
-}
-
-//Ajouter vos tests unitaires dans cette fonction.
-void tests_unitaires(void){
-    if (5!=5){
-        printf ("Erreur Test unitaire basique.\n");
-        exit(-1);
-    }
-    if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
-        printf ("Erreur Test unitaire trame_cmp.\n");
-        exit(-1);
-    }
-    if (trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
-        printf ("Erreur Test unitaire trame_cmp.\n");
-        exit(-1);
-    }
-    if (trame_cmp("$GPRMC... ", "GPRMC" )!=1){
-        printf ("Erreur Test unitaire trame_cmp.\n");
-        exit(-1);
-    }
-    if (trame_cmp("$APRMC...", "GPGGA")!=0){
-        printf ("Erreur Test unitaire trame_cmp.\n");
-        exit(-1);
-    }
-}
-
-// Ne pas modifier cette fonction
-int main(int argc,char ** argv)
-{
-
-    tests_unitaires();
-
-    // Affichage des trames definies dans la table trames.
-    printf ("Trames de tests tableau trames:\n");
-    int i=0;
-    while (trames[i])
-        traitement(trames[i++]);
-
-    if (!trame_init())
-        exit(-1);
-    // Affichage des trames du fichier gps.log
-    char *trame;
-    printf ("Trames de tests du fichier gps.log\n");
-    while  ((trame = trame_suivante()))
-        traitement(trame);
-
-    return 0;
-}