Index: tag/Morales/RC_0.9/main.c
===================================================================
--- tag/Morales/RC_0.9/main.c	(nonexistent)
+++ tag/Morales/RC_0.9/main.c	(revision 238)
@@ -0,0 +1,518 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
+#include <math.h>
+#include "trame.h"
+/*
+****************************
+    DONNEES CONSTANTES
+****************************
+*/
+//Trames de tests
+char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
+                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
+                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
+                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
+                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
+                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
+                    "$GPZDA,141914.00,01,02,2006,00,00*69",
+                    0};
+
+// structure pour la longitude et la latitude.
+typedef struct {
+float latitude;
+float longitude;
+} Position ;
+
+//structure des zones dangereuses
+typedef struct {
+ Position rpos;
+ float vitmax;
+ } Zone ;
+
+ // zones dangereuses
+Zone zones[] = {
+ {{44.7887762, -3.012}, 50}, /* Descripteur de la première zone */
+ {{44.7891220, -3.013}, 70}, /* Descripteur de la 2eme zone */
+ {{44.8384094, -3.013005}, 110}, /* Descripteur de la 3eme zone */
+ {{44.9312729, -3.018929}, 130}, /* Descripteur de la 4eme zone */
+ {{45.7531, 3.11001}, 30}, /* Descripteur de la 5eme zone */
+ {{45.3004, 3.00154635}, 20},  /* Descripteur de la 6eme zone */
+ {{45.7503, 3.11}, 30},    /* Descripteur de la 7eme zone */
+ {{45.2433, 3.085264}, 160},   /* Descripteur de la 8eme zone */
+ {{45.7502, 3}, 140},           /* Descripteur de la 9eme zone */
+ {{45.1248, 3.00094635},80},   /* Descripteur de la 10eme zone */
+ {{45.75350, 3.11}, 90},           /* Descripteur de la 11eme zone */
+};
+#define nbr_zones 11            // definit le nombre total de zones dangereuses.
+
+// initialisation des fonctions.
+int trame_cmp(char* trame,char* type);
+int decode_int (char c);
+int decode_nombre(char * ch,int n);
+float sexagesimal_to_float(char* value);
+int decode_trame (char*trame, Position *p);
+float calcul_vitesse (Position pos, Position pos_prec);
+int distance_a_la_plus_proche_zone (Position p, Zone r[], int nb_zones, float *d);
+void traitement(char * trame);
+
+/*
+*****************************
+    FONCTIONS DE CALCUL
+*****************************
+*/
+//fonction comparant les trames
+int trame_cmp(char* trame,char* type)
+{
+int i=1;                // initialisé à 1 pour ne pas prendre en compte le $
+int end_comp=1;                    //permet de savoir quand arreter la comparaison
+    while (end_comp!='\0')         // comparaison
+    {
+        if (trame[i]!=type[i-1])
+        {
+            return 0;            // si le trames sont differentes, on retourne 0
+        }
+        i=i+1;
+        end_comp=type[i];
+    }
+return 1;   // retourne 1 si les trames sont les mêmes
+}
+
+//fonction qui retourne l'entier correspondant au caractere mis en argument. (le caractère '1' retourne l'entier 1)
+int decode_int (char c)
+{
+int return_var=0;          // variable de retour
+    if ((c>=48)&&(c<=57))
+    {
+        return_var=c-48;    //si "c" est un chiffre, on le retourne en tant qu'entier
+    }
+    else
+    {
+        (return_var=-1);    // si "c" est autre chose, on retourne -1
+    }
+return return_var;
+}
+
+//fonction retournant uniquement les n premier chiffres dans un nombre.
+int decode_nombre(char * ch,int n)
+{
+int i=0;
+int nbr_return=0;       //nombre retourne
+    while (i<n)
+    {
+        nbr_return = nbr_return*10 + decode_int(ch[i]);
+        i=i+1;
+    }
+return nbr_return;
+}
+
+//fonction covertissant des sexagesimal (latitude ou longitude) en reel
+float sexagesimal_to_float(char* value)
+{
+int i=0;
+int j=0;
+int val_entiere_taille = 0;  // taille de la partie entiere de la valeur
+int val_decimale_taille = 0; // taille de la partie decimal de la valeur
+char val_entiere[10]={0};    //valeur entiere de la longitude, on reserve 6 cases par sécurite.
+char val_decimal[10]={0};    //valeur decimale de la longitude, on reserve 6 cases par sécurite.
+float sexages_value=0;
+float float_val=0;
+
+// on ne peux pas passer directement d'un caractère avec des virgule à un flottant, du coup on passe par deux chaîne de caractères
+// intermediares pour avoir ce qui correspond à la partie entière et ce qui correspond à la partie decimale
+
+        while (value[i]!='.')   // on s'arrete au point dans la chaine de caractère qui marque la separation entre partie reelle et decimale
+        {
+            val_entiere[j]=value[i];
+            j++;           // stock la partie entiere
+            i++;
+        }
+        val_entiere_taille = j;
+
+        j=0;    //reinitialise j
+        i++;    // on ne stock pas le point dans les 2 chaines
+
+        while (value[i]!='\0')
+        {
+            val_decimal[j]=value[i];            // stock la partie decimale
+            j++;
+            i++;
+        }
+        val_decimale_taille = j;
+
+// stockage de la valeur sexagesimale
+sexages_value = decode_nombre(val_entiere,val_entiere_taille) + 0.0001* decode_nombre(val_decimal,val_decimale_taille);
+
+//conversion en decimal
+int float_deg=sexages_value/100;
+float float_minutes=0;
+
+    float_minutes = (sexages_value-float_deg*100)/60;
+    float_val = float_deg + float_minutes;
+
+return float_val;
+}
+
+//fonction convertissant la latitude et longitude en reels.
+int decode_trame(char* trame,Position *p)
+{
+int i=0;
+int j=0;
+int nbr_virgule=0;
+char lat[15]={0};
+char longit[15]={0};
+    if (trame_cmp(trame,"GPGGA")==0)
+    {
+        return 0;
+    }
+//calcul latitude
+        while (nbr_virgule<3)       // on compte jusqu'a la troisieme virgule
+        {
+            while (nbr_virgule<2)   // on compte jusqu'a la deuxieme virugle (troisieme champs)
+            {
+                if (trame[i]==',')
+                {
+                    nbr_virgule = nbr_virgule+1;
+                }
+                i++;
+            }
+
+            lat[j]=trame[i];
+            j++;
+            i++;
+           if (trame[i]==',')
+           {
+              nbr_virgule = nbr_virgule+1;
+           }
+
+        }
+
+        p->latitude = sexagesimal_to_float(lat);      // transformation en flottant
+
+        if ((p->latitude>90)||(p->latitude<(-90)))      // verifie validite de la latitude
+        {
+            return 0;
+        }
+
+        j=0;     //reinitialise j
+        i++;     // une itération de i pour avoir i!=','
+
+// calcul longitude
+         while (nbr_virgule<5)       // on compte jusqu'a la troisieme virgule
+        {
+            while (nbr_virgule<4)   // on compte jusqu'a la deuxieme virugle (cinquieme champs)
+            {
+                if (trame[i]==',')
+                {
+                    nbr_virgule = nbr_virgule+1;
+                }
+                i++;
+            }
+
+            longit[j]=trame[i];
+            j++;
+            i++;
+           if (trame[i]==',')
+           {
+              nbr_virgule = nbr_virgule+1;
+           }
+
+        }
+
+        p->longitude = sexagesimal_to_float(longit);      // transformation en flottant
+
+        if ((p->longitude>180)||(p->longitude<(-180)))      // verifie validite de la longitude
+        {
+            return 0;
+        }
+
+return 1;   //retour 1 si tout est OK
+}
+
+//fonction revoyant la vitesse du vehicule a partir de sa position
+float calcul_vitesse (Position pos, Position pos_prec)
+{
+float v=0;
+float d=0;        //calcul la distance entre les deux points.
+float x=0;        // calcul intermediare
+float y=0;        // calcul intermediaire
+
+    x=(pos.longitude-pos_prec.longitude)*cos((pos.latitude+pos_prec.latitude)/2);
+    y=pos.latitude-pos_prec.latitude;
+    d= 1.852*60*sqrt(x*x + y*y);
+    v=d*3600;    // passage km/s a km/h (1 seconde d'interval entre 2 trames)
+return v;
+}
+
+//fonction calculant la distance à la plus proche zone et renvoyant le numero de cette zone.
+int distance_a_la_plus_proche_zone (Position p, Zone r[], int nb_zones, float *d)
+{
+int i =0;
+int num_zone=-1;    // numero de la zone la plus proche
+
+    *d=40075.017 ; // perimètre de la terre (distance max) en km
+
+    for (i=0;i<nb_zones;i++)
+    {
+        //verifie si la distance a la zone i est plus petite que celle a la zone i-1
+        if (sqrt((p.latitude - r[i].rpos.latitude)*(p.latitude - r[i].rpos.latitude)+(p.longitude-r[i].rpos.longitude)*(p.longitude-r[i].rpos.longitude))<=*d)
+        {
+            *d=sqrt((p.latitude - r[i].rpos.latitude)*(p.latitude - r[i].rpos.latitude)+(p.longitude-r[i].rpos.longitude)*(p.longitude-r[i].rpos.longitude));
+            num_zone=i;
+        }
+    }
+return num_zone;
+}
+
+
+
+/*
+***************************
+    BLOC TRAITEMENT
+***************************
+*/
+Position p;         // position au temps t
+Position p_prec;    // position à t-1 (1 seconde avant t)
+
+//Fonction traitement
+void traitement(char * trame)
+{
+
+float distance_zone=0;
+int num_zone=-1;
+float vitesse=0;
+static int cpt = 0;
+    cpt++;
+
+    if (decode_trame(trame,&p))
+    {
+        printf ("> %s\n",trame);
+
+        printf("latitude en reel : %f\n",p.latitude);
+        printf("longitude en reel : %f\n",p.longitude);
+        num_zone=distance_a_la_plus_proche_zone (p, zones, nbr_zones, &distance_zone);
+        printf ("zone la plus proche : zone numero %d, a %f km.\n",num_zone+1,distance_zone);
+        vitesse = calcul_vitesse (p, p_prec);
+
+        if (calcul_vitesse (p, p_prec)<1000)      // la premiere vitesse est fausse puisqu'on a pas de valeur précedente donc on met ca pour eviter d'afficher des erreurs.
+        {                                         // puisqu'aucune voiture ne va a plus de 1000km/h, cela devrait être suffisant.
+            printf("vitesse entre les positions : %f km/h\n",vitesse);
+
+            if ((vitesse > zones[num_zone].vitmax)&&(distance_zone<10))
+            {
+                printf("********\nalarm on\n********\n\n");
+            }
+            else
+            {
+                printf("alarm off\n\n");
+            }
+        }
+
+
+    }
+    p_prec=p;
+
+}
+
+/*
+**************************
+    TESTS UNITAIRES
+**************************
+*/
+
+void tests_unitaires(void){
+
+    if (5!=5){
+        printf ("Erreur Test unitaire basique.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC... ", "GPRMC" )!=1){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$APRMC...", "GPGGA")!=0){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (decode_int('0')!=0)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+    if (decode_int('1')!=1)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+    if (decode_int('2')!=2)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+     if (decode_int('3')!=3)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+     if (decode_int('4')!=4)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+     if (decode_int('5')!=5)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+     if (decode_int('6')!=6)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+     if (decode_int('7')!=7)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+     if (decode_int('8')!=8)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+     if (decode_int('9')!=9)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+     if (decode_int('A')!=-1)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+    if (decode_nombre("7541",2)!=75)
+    {
+        printf ("Erreur Test unitaire decode_nombre.\n");
+        exit(-1);
+    }
+     if (decode_nombre("7541",3)!=754)
+    {
+        printf ("Erreur Test unitaire decode_nombre.\n");
+        exit(-1);
+    }
+     if (decode_nombre("123",3)!=123)
+    {
+        printf ("Erreur Test unitaire decode_nombre.\n");
+        exit(-1);
+    }
+    if (decode_nombre("987654321",2)!=98)
+    {
+        printf ("Erreur Test unitaire decode_nombre.\n");
+        exit(-1);
+    }
+    if ((sexagesimal_to_float ("3723.2475")<=37.387458)||(sexagesimal_to_float ("3723.2475")>=37.387459))
+    {
+        printf ("Erreur Test unitaire sexagesimal_to_float.\n");
+        exit(-1);
+    }
+    if ((sexagesimal_to_float ("00306.6036")<=3.11006)||(sexagesimal_to_float ("00306.6036")>=3.11007))
+    {
+        printf ("Erreur Test unitaire sexagesimal_to_float.\n");
+        exit(-1);
+    }
+
+    Position p;
+    Position p_prec;
+
+    if (decode_trame ("$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",&p)!=0)
+    {
+        printf ("Erreur Test unitaire decode_trame 1.\n");
+        exit(-1);
+    }
+    if (decode_trame ("$GPGGA,141914.00,9100.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",&p)!=0)
+    {
+        printf ("Erreur Test unitaire decode_trame 2.\n");
+        exit(-1);
+    }
+    if (decode_trame ("$GPGGA,141914.00,4545.0000,N,18106.6036,E,1,05,3.4,499.3,M,,M,,*7D",&p)!=0)
+    {
+        printf ("Erreur Test unitaire decode_trame 2.\n");
+        exit(-1);
+    }
+
+    p.latitude=45.75;
+    p.longitude=3.11006;
+    p_prec.latitude=45.75;
+    p_prec.longitude=3.11006;        //p = p_prec donc la vitesse devrait être nulle
+    float d=100;
+
+    if (calcul_vitesse (p,p_prec)!=0)
+    {
+        printf ("Erreur Test unitaire calcul_vitesse.\n");
+        exit(-1);
+    }
+
+    p_prec.latitude=45.7504;          //longitude et latitude de la preparation
+    p_prec.longitude=3.110065;
+
+    if ((calcul_vitesse (p,p_prec)<158)||(calcul_vitesse (p,p_prec)>161))       // on a une erreur de calcul de 3 km/h
+    {
+        printf ("Erreur Test unitaire calcul_vitesse.\n");
+        exit(-1);
+    }
+
+    p.latitude=44.9312729;
+    p.longitude=-3.018929;
+
+    if (distance_a_la_plus_proche_zone (p, zones, nbr_zones, &d)!=3)    // la fonction doit renvoyer la zone 4 (case 3 dans le tableau),
+    {                                                                   // qui correspond exactement à la latitude et longitude de p.
+        printf ("Erreur Test unitaire distance_a_la_plus_proche_zone.\n");
+        exit(-1);
+    }
+    if (d!=0)              // p est exactement à la latitude de la zone 4 donc d =0
+    {
+        printf ("Erreur Test unitaire distance_a_la_plus_proche_zone.\n");
+        exit(-1);
+    }
+    //RAZ des structures.
+    p.latitude=0;
+    p.longitude=0;
+    p_prec.latitude=0;
+    p_prec.longitude=0;
+}
+
+
+/*
+***************************
+    FONCTION PRINCIPALE
+***************************
+*/
+// Ne pas modifier cette fonction
+int main(int argc,char ** argv)
+{
+
+    tests_unitaires();
+    // Affichage des trames definies dans la table trames.
+    printf ("Trames de tests tableau trames:\n");
+    int i=0;
+    while (trames[i])
+        traitement(trames[i++]);
+
+    if (!trame_init())
+        exit(-1);
+    // Affichage des trames du fichier gps.log
+    char *trame;
+    printf ("Trames de tests du fichier gps.log\n");
+    while  ((trame = trame_suivante()))
+        traitement(trame);
+
+    return 0;
+}
Index: tag/Morales/RC_0.9/gps.log
===================================================================
--- tag/Morales/RC_0.9/gps.log	(nonexistent)
+++ tag/Morales/RC_0.9/gps.log	(revision 238)
@@ -0,0 +1,111 @@
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E
+$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C
+$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E
+$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*79
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,99.4,T,,M,0.4,N,0.7,K*57
+$GPZDA,141914.00,01,02,2006,00,00*69
+$GPGSV,3,1,10,01,13,142,46,03,48,144,47,11,41,277,,14,27,104,42*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141915.00,A,4545.6423,N,00306.6039,E,0.6,110.2,010206,,*31
+$GPGLL,4545.6423,N,00306.6039,E,141915.00,A*07
+$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,110.2,T,,M,0.6,N,1.2,K*67
+$GPZDA,141915.00,01,02,2006,00,00*68
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,41*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,49,28,15,320,*76
+$GPRMC,141916.00,A,4545.6422,N,00306.6037,E,0.1,211.1,010206,,*3B
+$GPGLL,4545.6422,N,00306.6037,E,141916.00,A*0B
+$GPGGA,141916.00,4545.0484,N,00306.6037,E,1,05,3.4,500.0,M,,M,,*70
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,211.1,T,,M,0.1,N,0.2,K*60
+$GPZDA,141916.00,01,02,2006,00,00*6B
+$GPGSV,3,1,10,01,13,142,45,03,48,144,48,11,41,277,,14,27,104,43*78
+$GPGSV,3,2,10,15,03,077,,18,04,041,44,19,85,271,,20,08,214,*7A
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141917.00,A,4545.6422,N,00306.6039,E,0.3,122.3,010206,,*37
+$GPGLL,4545.6422,N,00306.6039,E,141917.00,A*04
+$GPGGA,141917.00,4545.0726,N,00306.6039,E,1,05,3.4,499.6,M,,M,,*73
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,122.3,T,,M,0.3,N,0.5,K*64
+$GPZDA,141917.00,01,02,2006,00,00*6A
+$GPGSV,3,1,10,01,13,142,45,03,48,144,46,11,41,277,,14,27,104,41*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141918.00,A,4545.6421,N,00306.6034,E,0.5,252.2,010206,,*35
+$GPGLL,4545.6421,N,00306.6034,E,141918.00,A*05
+$GPGGA,141918.00,4545.0968,N,00306.6034,E,1,05,3.4,498.8,M,,M,,*7A
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,252.2,T,,M,0.5,N,1.0,K*63
+$GPZDA,141918.00,01,02,2006,00,00*65
+$GPGSV,3,1,10,01,13,142,45,03,48,144,48,11,41,277,,14,27,104,42*79
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141919.00,A,4545.6420,N,00306.6040,E,0.6,95.2,010206,,*0C
+$GPGLL,4545.6420,N,00306.6040,E,141919.00,A*06
+$GPGGA,141919.00,4545.1210,N,00306.6040,E,1,05,3.4,500.2,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,95.2,T,,M,0.6,N,1.2,K*5B
+$GPZDA,141919.00,01,02,2006,00,00*64
+$GPGSV,3,1,10,01,13,142,46,03,48,144,49,11,41,277,,14,27,104,42*7B
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141920.00,A,4545.6419,N,00306.6039,E,0.2,133.1,010206,,*38
+$GPGLL,4545.6419,N,00306.6039,E,141920.00,A*08
+$GPGGA,141920.00,4545.1410,N,00306.6039,E,1,05,3.4,500.0,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,133.1,T,,M,0.2,N,0.4,K*66
+$GPZDA,141920.00,01,02,2006,00,00*6E
+$GPGSV,3,1,10,01,13,142,45,03,48,144,46,11,41,277,,14,27,104,43*76
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,38,053,50,28,15,320,*7F
+$GPRMC,141921.00,A,4545.6419,N,00306.6043,E,0.6,103.1,010206,,*33
+$GPGLL,4545.6419,N,00306.6043,E,141921.00,A*04
+$GPGGA,141921.00,4545.1610,N,00306.6043,E,1,05,3.4,499.8,M,,M,,*70
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,103.1,T,,M,0.6,N,1.1,K*65
+$GPZDA,141921.00,01,02,2006,00,00*6F
+$GPGSV,3,1,10,01,13,142,46,03,48,144,48,11,41,277,,14,27,104,42*7A
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,38,053,48,28,15,320,*76
+$GPRMC,141922.00,A,4545.6418,N,00306.6046,E,0.7,96.9,010206,,*00
+$GPGLL,4545.6418,N,00306.6046,E,141922.00,A*03
+$GPGGA,141922.00,4545.1810,N,00306.6046,E,1,05,3.4,500.6,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,96.9,T,,M,0.7,N,1.3,K*53
+$GPZDA,141922.00,01,02,2006,00,00*6C
+$GPGSV,3,1,10,01,13,142,47,03,48,144,46,11,41,277,,14,27,104,43*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,48,28,15,320,*76
+$GPRMC,141923.00,A,4545.6417,N,00306.6046,E,0.3,113.6,010206,,*39
+$GPGLL,4545.6417,N,00306.6046,E,141923.00,A*0D
+$GPGGA,141923.00,4545.2010,N,00306.6046,E,1,05,3.4,500.6,M,,M,,*7D
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,113.6,T,,M,0.3,N,0.7,K*61
+$GPZDA,141923.00,01,02,2006,00,00*6D
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,41*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141924.00,A,4545.6416,N,00306.6044,E,0.2,197.7,010206,,*31
+$GPGLL,4545.6416,N,00306.6044,E,141924.00,A*09
+$GPGGA,141924.00,4545.2210,N,00306.6044,E,1,05,3.4,500.5,M,,M,,*79
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,197.7,T,,M,0.2,N,0.4,K*6E
+$GPZDA,141924.00,01,02,2006,00,00*6A
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,40*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141925.00,A,4545.6415,N,00306.6046,E,0.2,130.8,010206,,*33
+$GPGLL,4545.6415,N,00306.6046,E,141925.00,A*09
+$GPGGA,141925.00,4545.2410,N,00306.6046,E,1,05,3.4,501.4,M,,M,,*7C
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,130.8,T,,M,0.2,N,0.5,K*6D
+$GPZDA,141925.00,01,02,2006,00,00*6B
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,40*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,38,053,47,28,15,320,*79
+$GPRMC,141926.°E,0.2,260.8,010206,,*34
Index: tag/Morales/RC_0.9/trame.c
===================================================================
--- tag/Morales/RC_0.9/trame.c	(nonexistent)
+++ tag/Morales/RC_0.9/trame.c	(revision 238)
@@ -0,0 +1,28 @@
+/* Fichier trames.c - Gestion et decodage des trames */
+/* Ce fichier sera fourni */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include "trame.h"
+
+#define FICHIER_TRAMES "gps.log"  /* Par exemple */
+
+#define MAX_FRAME_LENGTH 80
+
+static char trame_buf[MAX_FRAME_LENGTH];
+static FILE *trame_fic;
+
+int trame_init(void)
+{
+    trame_fic = fopen(FICHIER_TRAMES, "r");
+    if (trame_fic)
+        return 1;
+
+    fprintf(stderr, "Impossible d'ouvrir le fichier %s\n", FICHIER_TRAMES);
+    return 0;
+}
+
+char *trame_suivante(void)
+{
+  return fgets(trame_buf, MAX_FRAME_LENGTH-1, trame_fic);
+}
Index: tag/Morales/RC_0.9/sp4a.cbp
===================================================================
--- tag/Morales/RC_0.9/sp4a.cbp	(nonexistent)
+++ tag/Morales/RC_0.9/sp4a.cbp	(revision 238)
@@ -0,0 +1,37 @@
+<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
+<CodeBlocks_project_file>
+	<FileVersion major="1" minor="6" />
+	<Project>
+		<Option title="sp4a" />
+		<Option pch_mode="2" />
+		<Option compiler="gcc" />
+		<Build>
+			<Target title="Debug">
+				<Option output="sp4a" prefix_auto="1" extension_auto="1" />
+				<Option object_output=".\debug" />
+				<Option type="1" />
+				<Option compiler="gcc" />
+				<Compiler>
+					<Add option="-g" />
+				</Compiler>
+			</Target>
+		</Build>
+		<Compiler>
+			<Add option="-Wall" />
+		</Compiler>
+		<Unit filename="gps.log" />
+		<Unit filename="main.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="trame.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="trame.h" />
+		<Extensions>
+			<code_completion />
+			<envvars />
+			<debugger />
+			<lib_finder disable_auto="1" />
+		</Extensions>
+	</Project>
+</CodeBlocks_project_file>
Index: tag/Morales/RC_0.9/trame.h
===================================================================
--- tag/Morales/RC_0.9/trame.h	(nonexistent)
+++ tag/Morales/RC_0.9/trame.h	(revision 238)
@@ -0,0 +1,3 @@
+
+int trame_init(void);
+char * trame_suivante(void);